# -*- coding: utf-8 -*-

import logging
import os
import json
DEFAULT_LOGGING_LEVEL = logging.DEBUG
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

try:
    from cloghandler import ConcurrentRotatingFileHandler as RFHandler  # pip install ConcurrentLogHandler
except ImportError:
    from logging.handlers import RotatingFileHandler as RFHandler

class TranslateLog(object):

    # def __init__(self, translate_result, source_lang, target_lang, text):
    #     self.m_TranslateResult = translate_result
    #     self.m_SourceLang = source_lang
    #     self.m_TargetLang = target_lang
    #     self.m_Text = text

    def logHandler(self, translate_result, text, target_lang, source_lang=None):
        if not source_lang:
            source_lang = self.m_LogName
        result = translate_result.get("ret",False)
        if result:
            _count = 0
            translatedTexts = translate_result.get("data",[])
            for translatedText in translatedTexts:
                translate_log = {
                    "source_lan": source_lang,
                    "target_lan": target_lang,
                    "text": text[_count],
                    "translate_text": translatedText
                }
                self.info(json.dumps(translate_log))
                _count += 1

    def __init__(self, log_name):
        self.mylog  = logging.getLogger(log_name)
        self.m_LogName = log_name
        try:
            # self.mylog = mylog = logging.getLogger(self.m_SourceLang)
            #log_path_dir = BASE_DIR + "/log"
            log_path_dir = "/sql_data/translate_log"
           
            if not os.path.exists(log_path_dir):
                os.mkdir(log_path_dir)
            print log_path_dir
            formatter = logging.Formatter('%(asctime)s - %(filename)s[line:%(lineno)d] - %(name)s - %(levelname)s - %(message)s')
            handler = RFHandler(log_path_dir + "/translate_" + log_name + ".log")
            handler.setFormatter(formatter)
            # filter = logging.Filter('s')  # 过滤器 会记录s, s.s2的信息
            # mylog.addFilter(filter)
            for h in self.mylog.handlers:
                if type(h) == RFHandler:
                    self.mylog.removeHandler(h)
            self.mylog.addHandler(handler)

            if True:
                for h in self.mylog.handlers:
                    if type(h) == logging.StreamHandler:
                        self.mylog.removeHandler(h)
                console_handler = logging.StreamHandler()
                console_handler.setFormatter(formatter)
                self.mylog.addHandler(console_handler)
            self.mylog.setLevel(DEFAULT_LOGGING_LEVEL)
        except Exception as e:
            print e

    def info(self, msg, *args, **kwargs):
        try:
            self.mylog.info(msg, *args, **kwargs)
        except Exception as e:
            pass  # log never throw

    def debug(self, msg, *args, **kwargs):
        try:
            self.mylog.debug(msg, *args, **kwargs)
        except Exception as e:
            pass  # log never throw


